/*
   Copyright (c) 2010 - 2013 Javaika.com by Alexander Wait.
   
   All Rights Reserved.
*/



package required;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

import main.OnlineMessagingGui;


//********************************************* START CLASS *********************************************//


/**
 *  This class uploads/downloads video/audio to/from the server.
 *
 *  @author Alexander Wait
 *  @version 2014-07-25
 */
public class DataUploadDownload 
{
   private static final String FILE_DOWNLOAD_ADDRESS = "http://" + Domain.getDomain()
   
   + "/bridge/record-message-data-read.php" + Domain.getPort(); // Port:80 
   

   private static final String FILE_UPLOAD_ADDRESS = "http://" + Domain.getDomain()
   
   + "/bridge/record-message-data-write.php" + Domain.getPort(); // Port:80 
   

   private static final String BOUNDARY = "*****";
   
   private static final String LINE_END = "\r\n";
   
   private static final String HYPHENS = "--";

   
   private static final int BUFFER_SIZE = 1024;
   
   

   /**
    * Class constructor.
    * ESCA-JAVA0057:
    */
   public DataUploadDownload() {}
   
   
   
   /**
    * Writes a message object to the server.
    * @param userId
    * @param userPw
    * @param messageId
    * ESCA-JAVA0166:
    * ESCA-JAVA0266:
    * @param data
    */
   public void exportMessageData(String userId, String userPw, String messageId, byte[] data)
   {
      OnlineMessagingGui.appendTextOutput("\n Message send started.");
      
      OnlineMessagingGui.updateProgressBar("Sending Message", true);
 
      
      try
      {
         URL url = new URL(FILE_UPLOAD_ADDRESS);
         
         
         con = (HttpURLConnection) url.openConnection(); 

         con.setDoInput(true); con.setDoOutput(true); con.setUseCaches(false); 
         
         
         con.setRequestMethod("POST");   

         con.setRequestProperty("Connection", "Keep-Alive"); 

         con.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + BOUNDARY);
         

         dos = new DataOutputStream(con.getOutputStream()); 


         dos.writeBytes(HYPHENS + BOUNDARY + LINE_END);

         dos.writeBytes("Content-Disposition: form-data; name=userId;" + LINE_END + LINE_END);

         dos.writeBytes(userId + LINE_END);
         
         
         dos.writeBytes(HYPHENS + BOUNDARY + LINE_END);

         dos.writeBytes("Content-Disposition: form-data; name=userPw;" + LINE_END + LINE_END);

         dos.writeBytes(userPw + LINE_END);
         
         
         dos.writeBytes(HYPHENS + BOUNDARY + LINE_END);

         dos.writeBytes("Content-Disposition: form-data; name=messageId;" + LINE_END + LINE_END);

         dos.writeBytes(messageId + LINE_END);
         
         
         dos.writeBytes(HYPHENS + BOUNDARY + LINE_END);

         dos.writeBytes("Content-Disposition: form-data; name=message; filename=output.dat" + LINE_END); 

         dos.writeBytes(LINE_END); dos.write(data); dos.writeBytes(LINE_END); 
         
         
         dos.writeBytes(HYPHENS + BOUNDARY + HYPHENS + LINE_END);

         bre = new BufferedReader(new InputStreamReader(con.getInputStream())); 
         
 
         while ((rec = bre.readLine()) != null) {OnlineMessagingGui.appendTextOutput("\n " + rec);}
         
         
         OnlineMessagingGui.appendTextOutput("\n Message send completed.");
         
         OnlineMessagingGui.updateProgressBar("Message Sent", false);

         
         dos.flush(); dos.close(); bre.close();
      }
   
      
      catch (Exception e) 
      {
         System.out.println("Could not upload to host.");
      }
   }
   
   
   
   /**
    * Reads a message object from the server.
    * @param userId
    * @param userPw
    * @param messageId
    * @param channelId
    * ESCA-JAVA0166:
    * ESCA-JAVA0266:
    * @return
    */
   public byte[] importMessageData(String userId, String userPw, String messageId, String channelId)
   {
      OnlineMessagingGui.appendTextOutput("\n Message receive started.");
      
      OnlineMessagingGui.updateProgressBar("Receiving Message", true);
      
      byte[] data = null;

      
      try 
      {
         URL url = new URL(FILE_DOWNLOAD_ADDRESS);
         

         con = (HttpURLConnection) url.openConnection(); 

         con.setDoInput(true); con.setDoOutput(true); con.setUseCaches(false); 


         con.setRequestMethod("POST"); 

         con.setRequestProperty("Connection", "Keep-Alive"); 

         con.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + BOUNDARY); 


         dos = new DataOutputStream(con.getOutputStream()); 
         
         
         dos.writeBytes(HYPHENS + BOUNDARY + LINE_END); 

         dos.writeBytes("Content-Disposition: form-data; name=userId" + LINE_END + LINE_END);

         dos.writeBytes(userId + LINE_END);
         
         
         dos.writeBytes(HYPHENS + BOUNDARY + LINE_END); 

         dos.writeBytes("Content-Disposition: form-data; name=userPw" + LINE_END + LINE_END);

         dos.writeBytes(userPw + LINE_END);
         
         
         dos.writeBytes(HYPHENS + BOUNDARY + LINE_END); 

         dos.writeBytes("Content-Disposition: form-data; name=messageId" + LINE_END + LINE_END);

         dos.writeBytes(messageId + LINE_END);
         
         
         dos.writeBytes(HYPHENS + BOUNDARY + LINE_END); 

         dos.writeBytes("Content-Disposition: form-data; name=channelId" + LINE_END + LINE_END);

         dos.writeBytes(channelId + LINE_END);
        
         
         dos.writeBytes(HYPHENS + BOUNDARY + HYPHENS + LINE_END); 
         
        
         dis = new DataInputStream(con.getInputStream());

         
         ByteArrayOutputStream baos = new ByteArrayOutputStream();
         
         byte[] buffer = new byte[BUFFER_SIZE]; int n = 0;
         
         
         while (-1 != (n = dis.read(buffer))) {baos.write(buffer, 0, n);}
         
         
         data = baos.toByteArray(); baos.reset();
         
         
         OnlineMessagingGui.appendTextOutput("\n Message receive completed."); 
         
         OnlineMessagingGui.updateProgressBar("Message Received", false);
         
         
         dos.flush(); dos.close(); dis.close();
      } 
      
      
      catch (Exception e) 
      {
         System.out.println("Could not download from host.");
      }


      return data;
   }
   
   
   
   /**
    * Returns the file download address.
    * @return
    */
   public static String getFileDownloadAddress()
   {
      return FILE_DOWNLOAD_ADDRESS;
   }
   
   
   
   /**
    * Returns the file download address.
    * @return
    */
   public static String getFileUploadAddress()
   {
      return FILE_UPLOAD_ADDRESS;
   }
   

   private String rec;
   private BufferedReader bre;
   private DataInputStream dis;
   private DataOutputStream dos;
   private HttpURLConnection con;

}


//********************************************** END CLASS **********************************************//